GNYR09F  Adjacent Bit Counts
For a string of n bits x1,x2,x3,...,Xn the adjacent bit count of the string (AdjBC(x)) is given by
X1*X2 + X2*X3 + X3*X4 + ... + Xn1 * Xn
which counts the number of times a 1 bit is adjacent to another 1 bit. For example:
AdjBC(011101101) = 3
AdjBC(111101101) = 4
AdjBC(010101010) = 0
Write a program which takes as input integers n and k and returns the number of bit strings x of n bits (out of 2ⁿ) that satisfy AdjBC(x) = k. For example, for 5 bit strings, there are 6 ways of getting AdjBC(x) = 2:
11100, 01110, 00111, 10111, 11101, 11011
Input
The first line of input contains a single integer P, (1 ≤ P ≤ 1000), which is the number of data sets that follow. Each data set is a single line that contains the data set number, followed by a space, followed by a decimal integer giving the number (n) of bits in the bit strings, followed by a single space, followed by a decimal integer (k) giving the desired adjacent bit count. The number of bits (n) will not be greater than 100 and the parameters n and k will be chosen so that the result will fit in a signed 32bit integer.
Output
For each data set there is one line of output. It contains the data set number followed by a single space, followed by the number of nbit strings with adjacent bit count equal to k.
Example
Input: 10
1 5 2
2 20 8
3 30 17
4 40 24
5 50 37
6 60 52
7 70 59
8 80 73
9 90 84
10 100 90
Output: 1 6
2 63426
3 1861225
4 168212501
5 44874764
6 160916
7 22937308
8 99167
9 15476
10 23076518
hide comments
hash7:
20160622 10:24:26
NYC QSN... 

karthik1997:
20160618 19:59:47
For Beginners striving for the subcase : Solve @www.spoj.com/problems/PERMUT1 First. and You can easily figure out the sub cases ... SImple 3D Dp with O(N*N*2) complexity . PS My complexity itself suggests the required space complexity tooo :D .... 

Ravi:
20160324 21:51:24
precompute + dp


lakshay_v06:
20160324 13:12:22
AC in one go! O(n^2) : 0.00 < :D 

anshal dwivedi:
20160105 17:24:46
yo!AC in one go...! Nice One ..:) 

Aswin Siva:
20151230 06:48:00
Any other (trivial) approach other than 3D DP ? Any Hints... 

Sarthak Munshi:
20151009 17:17:52
First time AC . Generate pattern for n=1..10 and k=1..10 using brute force . Observe pattern . Then easy DP . 

sneh shikhar:
20150825 18:35:53
3D DP :* BOTTOM UP!! 

arun:
20150802 07:53:31
@sanchit 10111 & 11101 

:.Mohib.::
20150625 01:57:48
Great que for beginners in dp like me...!! 
Added by:  Tamer 
Date:  20091114 
Time limit:  3s 
Source limit:  50000B 
Memory limit:  1536MB 
Cluster:  Cube (Intel G860) 
Languages:  All except: NODEJS objc PERL 6 VB.net 
Resource:  ACM Greater New York Regional Contest 2009 